//
// Created by Attila Haluska on 8/13/18.
//

#include "compiler/parser/ast/ast_node.h"

#include <stdlib.h>

#include "compiler/lexer/token.h"
#include "memory_management/memory.h"

AstNode* ast_node_make_integer(const Token* token) {
    AstNode* node = NEW(AstNode);

    char* end;

    node->type = NODE_INTEGER;
    node->token = token;
    node->as.integer = strtoll(node->token->start, &end, 10);

    return node;
}


AstNode* ast_node_make_double(const Token* token) {
    AstNode* node = NEW(AstNode);

    char* end;

    node->type = NODE_DOUBLE;
    node->token = token;
    node->as.double_precision = strtold(node->token->start, &end);

    return node;
}

AstNode* ast_node_make_binary_infix_expression(const Token* token, AstNode* left, AstNode* right) {
    AstNode* node = NEW(AstNode);

    node->type = NODE_BINARY_INFIX_OPERATOR;
    node->token = token;
    node->as.binaryInfix.left = left;
    node->as.binaryInfix.right = right;

    return node;
}
