//
// Created by Attila Haluska on 8/13/18.
//

#ifndef ASPL_C_AST_NODE_H
#define ASPL_C_AST_NODE_H

#include <stdint.h>

#include "forward_declarations.h"

typedef enum ast_node_type_t {
    NODE_INTEGER,
    NODE_DOUBLE,
    NODE_BINARY_INFIX_OPERATOR,
} AstNodeType;

typedef struct ast_node_t {
    AstNodeType type;
    const Token* token;
    union {
        struct {
            AstNode* left;
            AstNode* right;
        } binaryInfix;
        int64_t integer;
        long double double_precision;
    } as;
} AstNode;

extern AstNode* ast_node_make_integer(const Token* token);
extern AstNode* ast_node_make_double(const Token* token);
extern AstNode* ast_node_make_binary_infix_expression(const Token* token, AstNode* left, AstNode* right);

#endif //ASPL_C_AST_NODE_H
